# -*- coding: utf-8 -*-

# a helper program takes a list of unordered words and returns a sorted and counted list suitable for the "di" word list. Best run in python3 if non ASCII characters are being used.
import os
import sys

os.chdir(os.path.abspath(os.path.dirname(sys.argv[0])))

original_list = [
    "act","add","age","ago","air","all","and","any","are","art","bad","bed","big","bit","box","boy","but","buy","can","car","cat","cry","cut","day","did","dog","dry","eat","end","far","few","fig","fit","flu","fly","for","fun","gas","get","got","had","has","hat","her","him","his","hit","hot","how","ice","its","job","key","law","lay","led","let","lie","lot","low","man","map","may","men","new","nor","not","now","off","old","one","our","out","own","pay","per","pry","put","ran","red","row","run","sat","saw","say","sea","see","set","she","sir","sit","six","ski","sky","son","spy","sum","sun","ten","the","too","top","try","two","use","war","was","way","who","why","win","yes","yet","you","able","also","area","arms","army","away","baby","back","ball","bank","base","bear","beat","been","bell","best","bill","blab","blew","blip","blob","blot","blow","blue","boat","body","book","born","both","bran","brat","bray","brew","brim","busy","came","care","case","city","clad","clam","clan","clap","claw","clay","clip","clod","clog","club","clue","cold","come","cook","cool","copy","corn","cost","cows","crab","crib","crop","crow","dark","deal","deep","does","done","door","down","drab","drag","draw","drew","drip","drop","drum","each","ears","east","easy","edge","eggs","else","even","ever","eyes","face","fact","fair","fall","farm","fast","fear","feel","feet","fell","felt","find","fine","fire","fish","five","flag","flap","flat","flaw","flea","flew","flex","flip","flop","flow","food","foot","four","free","frog","from","full","game","gave","girl","give","glad","glee","glob","glow","glue","gold","gone","good","grab","gram","gray","grew","grid","grim","grin","grip","grit","grow","grub","hair","halt","hand","hard","have","head","hear","heat","held","help","here","high","hill","hold","hole","home","hope","huge","idea","into","iron","just","keep","kept","kind","king","knew","know","lady","lake","land","last","lead","left","legs","less","life","like","line","list","live","long","look","lost","loud","love","made","main","make","many","mark",
    "meet","milk","mind","mine","miss","moon","more","most","move","much","must","name","near","need","next","nose","note","noun","once","only","open","over","page","pair","park","part","past","plan","play","plod","plot","plow","plug","plum","poem","pole","poor","pray","prod","prop","race","rain","read","rest","rich","ride","ring","rise","road","rock","room","root","rope","rose","rule","safe","said","sail","same","sand","save","scab","scan","scar","scat","seat","seen","sell","send","sent","ship","shop","show","side","sign","sing","size","skid","skin","skip","skit","slab","slam","slap","sled","slid","slim","slip","slit","slot","slow","slug","smog","snag","snap","snip","snob","snow","snug","soft","soil","some","song","soon","span","spat","spin","spot","spur","star","stay","stem","step","stew","stir","stop","such","sure","swam","swan","swap","swat","sway","swim","tail","take","talk","tall","team","tell","test","than","that","them","then","they","thin","this","thus","tied","time","tiny","told","tone","took","town","trap","tray","tree","trek","trim","trip","trot","true","tube","turn","type","unit","upon","verb","very","view","wait","wall","want","warm","wash","wear","week","well","went","were","west","what","when","wide","wife","wild","will","wind","wire","wish","with","wood","work","yard","your","about","above","after","again","ahead","allow","alone","along","among","angle","apple","asked","began","being","below","birds","black","blade","blame","blank","blast","blaze","bleat","bleed","bleep","blend","bless","blind","blink","block","blood","bloom","bluff","blunt","blush","board","bones","brace","braid","brain","brake","brand","brass","brave","brawl","bread","break","brick","bride","bring","brisk","broad","broil","broke","brood","brook","broom","broth","brown","brush","build","built","carry","catch","cause","cells","cents","chart","check","child","clack","claim","clamp","clang","clash","clasp","class","clean","clear","cleat","clerk","click","cliff","climb","cling","clink","cloak","clock","clomp","close","cloth","cloud","clove","clown","cluck","clump","coast","could","count","crack","craft","crane","crash","crawl","crazy","creek","creep","cried","croak","crook","crops","cross","crowd","crown","crumb","crust","dance","draft","drain","drake","drank","drape","dread","dream","dress","drift","drill","drink","drive","droop","drove","early","earth","eight","enjoy","equal","every","field","fight","first","flake","flame","flare","flash","fleck","fleet","flesh","flick","fling","flint","float","flock","flood","floor","floss","flour","fluff","fluid","fluke","flunk","flush","flute","force","found","frail",
    "frame","frank","freak","fresh","frill","frizz","front","frost","fruit","glare","glass","gleam","glide","gloat","globe","gloom","gloss","glove","grace","grade","graft","grain","grand","grant","grape","graph","grasp","grass","grate","grave","gravy","graze","great","greed","green","greet","grill","grime","grind","groan","groom","group","growl","grown","gruff","grump","guess","happy","heard","heart","heavy","horse","hours","house","human","known","large","later","learn","least","leave","level","light","major","march","match","maybe","means","metal","might","miles","money","mouth","music","never","night","north","ocean","often","order","other","paint","paper","party","piece","place","plaid","plain","plane","plank","plant","plate","plead","pleat","plink","plump","point","power","press","price","pride","print","prize","probe","proof","proud","prove","prowl","prune","quiet","quite","radio","ready","right","river","round","scald","scale","scalp","scamp","scare","scarf","scold","scoop","scoot","scope","score","scour","scout","scram","scrap","screw","scrub","scuba","scuff","seeds","sense","serve","seven","shall","shape","sharp","shoes","short","shown","sight","since","skate","skill","skirt","skull","skunk","slack","slant","slate","sleek","sleep","sleet","slept","slice","slick","slide","slime","sling","slope","slump","slush","smack","small","smart","smash","smear","smell","smile","smock","smoke","snack","snail","snake","snare",
    "snarl","sneak","sniff","snoop","snore","snout","solve","sound","south","space","spare","spark","speak","spear","speck","speed","spell","spend","spent","spike","spill","spine","spire","split","spoil","spoke","spoon","sport","spout","spray","sprig","squat","squid","stack","staff","stage","stain","stair","stake","stale","stalk","stall","stamp","stand","stare","stars","start","state","steak","steal","steam","steel","steep","steer","stick","stiff","still","stilt","sting","stink","stock","stone","stood","stool","stoop","store","storm","story","stove","strap","straw","stray","strip","strum","study","style","sugar","swamp","swarm","sweat","sweep","sweet","swell","swept","swift","swine","swing","swish","swoop","table","terms","their","there","these","thick","thing","think","third","those","three","today","tools","total","touch","trace","track","trade","trail","train","tramp","trash","tread","treat","trees","tribe","trick","troll","tromp","troop","trout","truck","truly","trunk","trust","truth","uncle","under","until","value","visit","voice","vowel","watch","water","waves","where","which","while","white","whole","whose","wings","woman","women","words","world","would","write","wrong","wrote","years","young","across","action","afraid","agreed","almost","always","amount","answer","appear","around","became","become","before","behind","belong","beside","better","bleach","blonde","blouse","bottom","bought","braise","branch","breath","breeze","bridge","bright","broken","bronco","bronze","browse","bruise","called","cannot","cattle","caught","centre","chance","change","choose","church","circle","closet","clutch","colour","column","common","corner","cotton","course","cradle","crayon","create","crunch","desert","design","direct","doctor","dragon","during","effect","either","energy","engine","enough","entire","except","expect","family","famous","father","figure","filled","flight","flower","forest","freeze","friend","fright","fringe","frozen","garden","glance","glitch","grapes","grease","grouch","ground","grudge","inches","inside","island","itself","joined","jumped","killed","length","lifted","listen","little","matter","melody","method","middle","modern","moment","months","mother","nation","notice","number","object","office","oxygen","passed","people","period","person","phrase", "picked","plains","planet","plants","player","please","pledge","plenty","plural","pounds","praise","prance","prayer","pretty","priest","prince","prison","pulled","pushed","raised","rather","really","reason","record","region","remain","report","result","return","rhythm","rolled","scarce","school",
    "scorch","scrape","scrawl","scream","screen","script","scroll","second","seemed","should","silent","simple","single","sister","sketch","sleepy","sleeve","slight","slowly","smiled","smooth","smudge","snatch","sneeze","speech","spirit","splash","splint","sponge","sprain","sprang","sprawl","spread","spring","sprint","sprout","spruce","square","squash","squeak","squeal","squint","squirm","squirt","squish","stable","staple","starch","starve","statue","steady","stereo","sticky","stingy","stitch","strain","strand","streak","stream","street","strict","stride","strike","string","stripe","stroke","stroll","strong","struck","suffix","summer","supply","swatch","swerve","switch","system","though","toward","travel","trough","valley","walked","weight","wheels","window","winter","within","wonder","yellow","against","already","animals","another","arrived","because","believe","between","blanket","blossom","brother","brought","burning","capital","captain","century","certain","climate","climbed","clothes","company","compare","contain","control","correct","country","covered","cricket","current","decided","decimal","details","distant","divided","dollars","drawing","entered","evening","exactly","example","explain","express","factors","farmers","feeling","finally","fingers","flowers","forward","freight","friends","general","gravity","himself","history","however","hundred","hunting","include","insects","instead","laughed","letters","located","machine","measure","members","million","minutes","morning","natural","nothing","numeral","observe","outside","pattern","perhaps","picture","planets","prepare","present","pretzel","printed","problem","process","produce","product","program","project","promise","pronoun","protect","provide","quickly","reached","scallop","science","scooter","scraper","scratch","screech","section","settled","several","shouted","similar","skillet","slipper","snuggle","someone","special","squeeze","stadium","stapler","started","station","stirrup","stomach","strange","stretch","subject","suppose","surface","swallow","sweater","sweeten","swollen","symbols","teacher","thought","through","trouble","trumpet","usually","various","village","weather","western","whether","without","workers","written","actually","addition","although","anything","blizzard","branches","building","business","children","clothing","complete","compound","consider","describe","division","electric","elements","equation","everyone","exciting","exercise","finished","fraction","freckles","happened","increase","indicate","industry","interest","language",
    "material","movement","northern","opposite","pleasant","position","possible","practice","practise","precious","prepared","princess","prisoner","probably","products","property","received","remember","repeated","scallion","scramble","scribble","sentence","separate","shoulder","soldiers","solution","southern","splendid","splinter","sprinkle","squirrel","starfish","stocking","straight","strainer","stranger","strength","stronger","struggle","students","suddenly","surprise","together","triangle","yourself","adjective","beautiful","beginning","carefully","consonant","continued","determine","developed","different","difficult","direction","factories","following","groceries","important","molecules","mountains","necessary","paragraph","president","principal","professor","pronounce","propeller","questions","represent","something","sometimes","sprinkler","statement","stretched","stretcher","suggested","syllables","thousands","underline","blackboard","conditions","dictionary","difference","discovered","especially","everything","experience","experiment","flashlight","government","particular","scientists","stationary","strawberry","substances","themselves","understand"
]
translated_list_of_words = [
"handelen","toevoegen","leeftijd","geleden","lucht","alles","en","elk","zijn","kunst","slecht","bed","groot","bit","doos","jongen","maar","kopen","kan","auto","kat","huilen","knippen","dag","deed","hond","droog","eten","einde","ver","paar","vijg","fit","griep","vlieg","voor","plezier","gas","krijg","kreeg","had","heeft","hoed","haar","hem","zijn","geraakt","heet","hoe","ijs","its","job","key","law","lay","led","let","lie","lot","low","man","map","may","men","new","noch","not","now","off","old","one","our","out","own","pay","per","wrikken","gezet","liep","rood","rij","rennen","zat","zag","zeg","zee","zie","stel","zij","mijnheer","zit","zes","ski","hemel","zoon","spion","som","zon","tien","de","ook","top","probeer","twee","gebruik","oorlog","was","manier","wie","waarom","win","gebied","wapens","leger","weg","baby","rug","bal","bank","basis","beer","verslaan","geweest","bel","best","bill","blab","blies","blip","blob","vlek","blazen","blauw","boot","lichaam","boek","geboren","beide","zemelen","snotaap","bray","brouwen","rand","druk","kwam","zorg","geval","stad","bekleed","clan","klap","klauw","klei","klem","kluit","klomp","club","aanwijzing","koud","kom","kok","koel","exemplaar","maïs","kosten","koeien","krab","wieg","gewas","kraai","donker","deal","diep","doet","gedaan","deur","omlaag","saai","slepen","trok","druppelen","laten","vallen","trommel","elk","oren","oosten","gemakkelijk","rand","eieren","anders","zelfs","ooit","ogen","gezicht","feit","eerlijk","vallen","boerderij","snel","angst","voelen","voeten","viel","voelde","zoeken","fijn","vuur","vis","vijf","vlag","klep","plat","fout","vlo","vloog","flex","flip","flop","stroom","eten","voet","vier","gratis","kikker","uit","vol","spel","gaf","meisje","geef","blij","vrolijk","glob","gloed","lijm","goud","verdwenen","goed","grijper","gram","grijs","groeide","rooster","grimmig","grijns","grip","grit","groeien","rups","haar","halt","hand","hard","hebben","hoofd","horen","warmte","vastgehouden","helpen","hier","hoog","heuvel","vasthouden","gat","huis","hoop","enorm","idee","in","ijzer","gewoon","houden","bewaard","vriendelijk","koning","dame","meer","land","laatste","leiden","links","benen","minder","leven","zoals","lijn","lijst","leven","lang","kijk","verloren","luid","liefde","gemaakt","main","maken","velen","markeren","ontmoeten","melk","geest","juffrouw","maan","meer","meest","verplaatsen","veel","moet","naam","dichtbij","behoefte","volgende","neus","notitie","eenmalig","alleen","open","over","pagina","paar","park","deel","verleden","plan","spelen","plod","plot","ploeg","plug","pruim","gedicht","pool","arm","bidden","prik","prop","race","regen","lezen","rust","rijk","rit","ring","stijgen","weg","rock","kamer","wortel","touw","roos","regel","veilig","zei","zeil","zelfde","zand","opslaan","schurft","scan","litteken","scat","stoel","gezien","verkopen","verzenden","verzonden","schip","winkel","tonen","kant","teken","zing","grootte","skid","skin","skip","skit","slab","slam","klap","slee","gleed","slank","slip","gleuf","gleuf","langzaam","slak","smog","addertje","gras","breuk","knip","snob","sneeuw","knus","zacht","bodem","wat","lied","binnenkort","span","spuug","draai","vlek","uitloper","ster","verblijf","stengel","stap","stoofpot","roer","stop","zoals","zeker","zwom","zwaan","ruil","swat","zwaaien","zwemmen","staart","neem","praat","lang","team","vertel","test","dan","dat","dan","zij","dun","dit","dus","gebonden","tijd","klein","verteld","toon","nam","stad","val","dienblad","boom","trektocht","trimmen","reis","draf","waar","buis","beurt","type","eenheid","werkwoord","zeer","uitzicht","wachten","muur","willen","warm","wassen","slijtage","week","nou","ging","waren","west","wat","wanneer","breed","vrouw","wild","wil","wind","draad","wens","met","hout","werk","tuin","je","over","boven","na","opnieuw","vooruit","toestaan","alleen","langs","onder","hoek","appel","vroeg","begon","zijnde","hieronder","vogels","zwart","mes","schuld","leeg","ontploffing","ontploffing","blaten","bloeden","piepen","mengen","zegenen","blind","knipperen","blokkeren","bloed","bloeien","bluffen","bot","blozen","bord","botten","schoren","vlecht","hersenen","rem","merk","messing","dapper","vechtpartij","brood","pauze","baksteen","bruid","brengen","levendig","breed","braden","brak","broeden","beek","bezem","bouillon","bruin","borstel","bouwen","gebouwd","dragen","vangen","oorzaak","cellen","centen","grafiek","selectievakje","kind","clack","claim","klem","clang","botsing","gesp","klasse","schoon","wissen","klik","klif","beklimmen","vastklampen","gerinkel","mantel","klok","clomp","sluiten","doek","wolk","kruidnagel","clown","kakelen","klomp","kust","kon","tellen","kraken","ambacht","kraan","crash","kruipen","gek","kreek","kruipen","huilde","kwaken","boef","gewassen","kruis","menigte","kroon","kruimel","korst","dans","ontwerp","afvoer","drake","dronk","draperen","dread","droom","jurk","boren","drinken","rijden","hangen","reed","vroeg","aarde","acht","genieten","gelijk","elk","veld","vechten","eerst","vlok","vlam","flare","flash","fleck","vloot","vlees","flick","fling","flint","float","flock","flood","floor","flos","meel","pluis","vloeistof","fluke","flunk","flush","flute","force","found","fragil","lijst","openhartig","buitenissig","vers","franje","kroes","voorzijde","vorst","fruit","schittering","glas","schijnsel","glijden","handschoen","wereldbol","somberheid","glans","handschoen","genade","rang","ent","graan","groot","subsidie","druif","grafiek","greep","gras","rooster","graf","jus","grazen","groot","hebzucht","groen","begroeten","grill","grime","grind","kreunen","bruidegom","groep","grommen","gegroeid","nors","grump","raden","gelukkig","gehoord","hart","zwaar","paard","uren","huis","menselijk","bekend","groot","later","leren","minst","verlof","niveau","licht","majoor","maart","lucifer","misschien","betekent","metaal","macht","mijlen","geld","mond","muziek","nooit","nacht","noorden","oceaan","vaak","bestelling","anders","verf","papier","feest","stuk","plaats","plaid","vlakte","vliegtuig","plank","plant","bord","pleiten","plooi","plink","mollig","punt","vermogen","pers","prijs","trots","print","prijs","sonde","bewijs","trots","bewijzen","snuffelen","snoeien","rustig","rustig","radio","klaar","recht","rivier","rond","verbranden","schaal","hoofdhuid","scamp","schrikken","sjaal","scold","scoop","scoot","scope","score","schuren","scout","scram","scrap","screw","scrub","scuba","scuff","zaden","sense","serve","seven","will","shape","sharp","schoenen","kort","getoond","zicht","sinds","vleet","vaardigheid","rok","schedel","stinkdier","slap","slant","lei","glad","slaap","ijzel","geslapen","plak","glad","glijbaan","slijm","slinger","helling","inzakking","sneeuwbrij","smack","small","smart","smash","smear","geur","glimlach","kiel","rook","snack","slak","slang","snare","grauwen","sluipen","snuiven","snuffelen","snurken","snuiten","oplossen","geluid","zuiden","ruimte","reserve","vonk","spreken","speer","stip","snelheid","spellen","uitgeven","besteed","spike","morsen","ruggengraat","torenspits","splitsen","verwennen","sprak","lepel","sport","uitloop","spray","takje","hurkzit","inktvis","stapel","personeel","podium","vlek","trap","ring","oudbakken","stengel","kraam","stempel","staan","staren","sterren","start","staat","biefstuk","stelen","stoom","staal","steil","sturen","stok","stijf","stil","stelten","steek","stinken","voorraad","steen","stond","kruk","bukken","winkel","storm","verhaal","fornuis","riem","stro","verdwaald","strip","strum","studie","stijl","suiker","moeras","zwerm","zweet","vegen","zoet","zwellen","geveegd","snel","varkens","schommel","swish","swoop","tafel","voorwaarden","hun","daar","deze","dik","ding","denk","derde","die","drie","vandaag","gereedschap","totaal","aanraken","spoor","spoor","handel","spoor","trein","zwerver","prullenbak","loopvlak","traktatie","bomen","stam","truc","trol","tromp","troep","forel","vrachtwagen","echt","kofferbak","vertrouwen","waarheid","oom","onder","tot","waarde","bezoek","stem","klinker","wacht","water","golven","waar","wat","terwijl","wit","heel","vrouw","vrouwen","woorden","wereld","zou","schrijven","verkeerd","schreef","jaren","jong","over","actie","bang","afgesproken","bijna","altijd","bedrag","antwoord","verschijnen","rond","werd","voor","achter","horen","horen","beter","bleekmiddel","blond","blouse","bodem","gekocht","stoof","tak","adem","bries","brug","helder","gebroken","bronco","brons","bladeren","kneuzing","genoemd","vee","gevangen","centrum","kans","verandering","kiezen","kerk","cirkel","kast","koppeling","kleur","kolom","gemeenschappelijk","hoek","katoen","cursus","wieg","krijt","creëren","crunch","woestijn","ontwerp","direct","dokter","draak","tijdens","effect","hetzij","energie","motor","genoeg","hele","behalve","verwachten","familie","beroemd","vader","figuur","gevuld","vlucht","bloem","bos","bevriezen","vriend","schrik","franje","bevroren","tuin","blik","glitch","druiven","vet","grouch","grond","wrok","inches","binnen","eiland","zelf","sprong","gedood","lengte","opgeheven","luister","weinig","materie","melodie","methode","midden","modern","moment","maanden","moeder","natie","kennisgeving","aantal","object","kantoor","zuurstof","geslaagd","persoon","zin","geplukt","vlaktes","planeet","planten","speler","alsjeblieft","belofte","veelvoud","meervoud","pond","lof","prance","gebed","mooi","priester","prins","gevangenis","getrokken","geduwd","verhoogd","liever","echt","reden","record","regio","blijven","rapport","resultaat","terugkeer","ritme","gerold","schaars","verschroeien","schrapen","krabben","gillen","scherm","script","bladeren","tweede","leek","stil","eenvoudig","single","zuster","schets","slaperig","mouw","licht","langzaam","glimlachte","glad","vlekken","rukken","niezen","spraak","geest","plons","spalk","spons","verstuiking","sprang","wildgroei","verspreiding","lente","sprint","spruit","sparren","vierkant","squash","piepen","piepen","squint","squirm","spuiten","squish","stabiel","nietje","zetmeel","verhongeren","standbeeld","vast","stereo","plakkerig","gierig","steek","spanning","strand","strook","stroom","straat","streng","pas","staking","touwtje","streep","beroerte","wandelen","sterk","geslagen","achtervoegsel","zomer","levering","staal","uitwijken","schakelaar","systeem","echter","reizen","trog","vallei","gelopen","gewicht","wielen","venster","winter","binnen","wonder","geel","tegen","al","dieren","arriveerde","omdat","geloof","tussen","deken","bloesem","broer","bracht","brandend","hoofdstad","kapitein","eeuw","zeker","klimaat","beklommen","kleding","bedrijf","vergelijken","bevatten","controle","corrigeren","land","bedekt","cricket","huidige","besloten","decimaal","details","ver","verdeeld","dollars","tekening","ingevoerd","avond","precies","bijvoorbeeld","uitleggen","uitdrukken","factoren","boeren","gevoel","eindelijk","vingers","bloemen","vooruit","vracht","vrienden","algemeen","zwaartekracht","zichzelf","geschiedenis","jacht","omvatten","insecten","lachte","brieven","gelegen","machine","meten","leden","miljoen","minuten","ochtend","natuurlijk","niets","cijfer","observeren","buiten","patroon","misschien","foto","planeten","bereiden","presenteren","krakeling","gedrukt","probleem","proces","produceren","product","programma","project","belofte","voornaamwoord","beschermen","bieden","snel","bereikt","wetenschap","scooter","schraper","kras","krijsen","sectie","geregeld","meerdere","geschreeuwd","vergelijkbaar","koekepan","pantoffel","lekker","iemand","speciaal","squeeze","stadion","nietmachine","gestart","station","stijgbeugel","maag","vreemd","stretch","onderwerp","veronderstel","oppervlak","slikken","trui","zoet","gezwollen","symbolen","leraar","gedachte","door","problemen","trompet","meestal","dorp","weer","western","of","zonder","arbeiders","geschreven","eigenlijk","toevoeging","hoewel","alles","sneeuwstorm","takken","gebouw","bedrijf","kinderen","kleding","compleet","samengesteld","overwegen","beschrijven","divisie","elektrisch","elementen","vergelijking","iedereen","opwindend","oefening","afgewerkt","breuk","sproeten","gebeurde","verhogen","aangeven","branche","interesse","taal","materiaal","beweging","noordelijk","tegenover","aangenaam","positie","mogelijk","oefenen","oefenen","kostbaar","voorbereid","prinses","gevangene","waarschijnlijk","producten","eigendom","ontvangen","onthouden","herhaald","klauteren","krabbelen","zin","scheiden","schouder","soldaten","oplossing","zuidelijk","prachtig","splinter","bestrooi","eekhoorn","zeester","kous","recht","zeef","vreemdeling","kracht","sterker","strijd","studenten","plotseling","verrassing","samen","driehoek","jezelf","mooi","begin","zorgvuldig","medeklinker","vervolgde","bepalen","ontwikkeld","verschillend","moeilijk","richting","fabrieken","volgende","boodschappen","belangrijk","moleculen","bergen","noodzakelijk","paragraaf","president","directeur","professor","uitspraak","propeller","vragen","vertegenwoordigen","iets","soms","sprinkler","verklaring","uitgerekt","brancard","voorgesteld","lettergrepen","duizenden","onderstrepen","schoolbord","voorwaarden","woordenboek","verschil","ontdekt","vooral","alles","ervaring","experiment","zaklamp","overheid","wetenschappers","stationair","aardbei","stoffen","zelf"
]

mixed_list_of_words = []

# filter out any untranslated words (or any english words that appear in the original list)
for each in translated_list_of_words:
    if each not in original_list:
        mixed_list_of_words.append(each)

a = 0
for each in mixed_list_of_words:
    if len(each) > a:
        a = len(each)

word_sets = [[] for i in range(a)]
alphabet_lc = ['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u',
               'v', 'w', 'x', 'y', 'z']
alphabet_uc = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U',
               'V', 'W', 'X', 'Y', 'Z']
accents = []
alpha = []
alpha.extend(alphabet_lc)
alpha.extend(alphabet_uc)
alpha.extend(accents)
ignore = [" ", "-", "'"]

for each in mixed_list_of_words:
    b = len(each)
    if 2 < b < 11:
        if each.lower()[0] in alpha:
            one_word = True
            for letter in each:
                if letter in ignore:
                    one_word = False
            if one_word:
                # if not a duplicate
                if each.lower() not in word_sets[b - 1]:
                    word_sets[b - 1].append(each.lower())

# save to file
file_name = os.path.join("new_list.txt")

for each in word_sets:
    a = len(each)
    if a > 0:
        each.sort()
        row = list()
        row.append(a)
        row.extend(each)
        # print(row)
        # save to file instead
        with open(file_name, 'a') as f:
            f.write("      " + str(row) + ",\n")
print("Completed - check the %s file." % file_name)

"""
initial word list
act, add, age, ago, air, all, and, any, are, art, bad, bed, big, bit, box, boy, but, buy, can, car, cat, cry, cut, day, did, dog, dry, eat, end, far, few, fig, fit, flu, fly, for, fun, gas, get, got, had, has, hat, her, him, his, hit, hot, how, ice, its, job, key, law, lay, led, let, lie, lot, low, man, map, may, men, new, nor, not, now, off, old, one, our, out, own, pay, per, pry, put, ran, red, row, run, sat, saw, say, sea, see, set, she, sir, sit, six, ski, sky, son, spy, sum, sun, ten, the, too, top, try, two, use, war, was, way, who, why, win, yes, yet, you, able, also, area, arms, army, away, baby, back, ball, bank, base, bear, beat, been, bell, best, bill, blab, blew, blip, blob, blot, blow, blue, boat, body, book, born, both, bran, brat, bray, brew, brim, busy, came, care, case, city, clad, clam, clan, clap, claw, clay, clip, clod, clog, club, clue, cold, come, cook, cool, copy, corn, cost, cows, crab, crib, crop, crow, dark, deal, deep, does, done, door, down, drab, drag, draw, drew, drip, drop, drum, each, ears, east, easy, edge, eggs, else, even, ever, eyes, face, fact, fair, fall, farm, fast, fear, feel, feet, fell, felt, find, fine, fire, fish, five, flag, flap, flat, flaw, flea, flew, flex, flip, flop, flow, food, foot, four, free, frog, from, full, game, gave, girl, give, glad, glee, glob, glow, glue, gold, gone, good, grab, gram, gray, grew, grid, grim, grin, grip, grit, grow, grub, hair, halt, hand, hard, have, head, hear, heat, held, help, here, high, hill, hold, hole, home, hope, huge, idea, into, iron, just, keep, kept, kind, king, knew, know, lady, lake, land, last, lead, left, legs, less, life, like, line, list, live, long, look, lost, loud, love, made, main, make, many, mark,
meet, milk, mind, mine, miss, moon, more, most, move, much, must, name, near, need, next, nose, note, noun, once, only, open, over, page, pair, park, part, past, plan, play, plod, plot, plow, plug, plum, poem, pole, poor, pray, prod, prop, race, rain, read, rest, rich, ride, ring, rise, road, rock, room, root, rope, rose, rule, safe, said, sail, same, sand, save, scab, scan, scar, scat, seat, seen, sell, send, sent, ship, shop, show, side, sign, sing, size, skid, skin, skip, skit, slab, slam, slap, sled, slid, slim, slip, slit, slot, slow, slug, smog, snag, snap, snip, snob, snow, snug, soft, soil, some, song, soon, span, spat, spin, spot, spur, star, stay, stem, step, stew, stir, stop, such, sure, swam, swan, swap, swat, sway, swim, tail, take, talk, tall, team, tell, test, than, that, them, then, they, thin, this, thus, tied, time, tiny, told, tone, took, town, trap, tray, tree, trek, trim, trip, trot, true, tube, turn, type, unit, upon, verb, very, view, wait, wall, want, warm, wash, wear, week, well, went, were, west, what, when, wide, wife, wild, will, wind, wire, wish, with, wood, work, yard, your, about, above, after, again, ahead, allow, alone, along, among, angle, apple, asked, began, being, below, birds, black, blade, blame, blank, blast, blaze, bleat, bleed, bleep, blend, bless, blind, blink, block, blood, bloom, bluff, blunt, blush, board, bones, brace, braid, brain, brake, brand, brass, brave, brawl, bread, break, brick, bride, bring, brisk, broad, broil, broke, brood, brook, broom, broth, brown, brush, build, built, carry, catch, cause, cells, cents, chart, check, child, clack, claim, clamp, clang, clash, clasp, class, clean, clear, cleat, clerk, click, cliff, climb, cling, clink, cloak, clock, clomp, close, cloth, cloud, clove, clown, cluck, clump, coast, could, count, crack, craft, crane, crash, crawl, crazy, creek, creep, cried, croak, crook, crops, cross, crowd, crown, crumb, crust, dance, draft, drain, drake, drank, drape, dread, dream, dress, drift, drill, drink, drive, droop, drove, early, earth, eight, enjoy, equal, every, field, fight, first, flake, flame, flare, flash, fleck, fleet, flesh, flick, fling, flint, float, flock, flood, floor, floss, flour, fluff, fluid, fluke, flunk, flush, flute, force, found, frail,
frame, frank, freak, fresh, frill, frizz, front, frost, fruit, glare, glass, gleam, glide, gloat, globe, gloom, gloss, glove, grace, grade, graft, grain, grand, grant, grape, graph, grasp, grass, grate, grave, gravy, graze, great, greed, green, greet, grill, grime, grind, groan, groom, group, growl, grown, gruff, grump, guess, happy, heard, heart, heavy, horse, hours, house, human, known, large, later, learn, least, leave, level, light, major, march, match, maybe, means, metal, might, miles, money, mouth, music, never, night, north, ocean, often, order, other, paint, paper, party, piece, place, plaid, plain, plane, plank, plant, plate, plead, pleat, plink, plump, point, power, press, price, pride, print, prize, probe, proof, proud, prove, prowl, prune, quiet, quite, radio, ready, right, river, round, scald, scale, scalp, scamp, scare, scarf, scold, scoop, scoot, scope, score, scour, scout, scram, scrap, screw, scrub, scuba, scuff, seeds, sense, serve, seven, shall, shape, sharp, shoes, short, shown, sight, since, skate, skill, skirt, skull, skunk, slack, slant, slate, sleek, sleep, sleet, slept, slice, slick, slide, slime, sling, slope, slump, slush, smack, small, smart, smash, smear, smell, smile, smock, smoke, snack, snail, snake, snare,
snarl, sneak, sniff, snoop, snore, snout, solve, sound, south, space, spare, spark, speak, spear, speck, speed, spell, spend, spent, spike, spill, spine, spire, split, spoil, spoke, spoon, sport, spout, spray, sprig, squat, squid, stack, staff, stage, stain, stair, stake, stale, stalk, stall, stamp, stand, stare, stars, start, state, steak, steal, steam, steel, steep, steer, stick, stiff, still, stilt, sting, stink, stock, stone, stood, stool, stoop, store, storm, story, stove, strap, straw, stray, strip, strum, study, style, sugar, swamp, swarm, sweat, sweep, sweet, swell, swept, swift, swine, swing, swish, swoop, table, terms, their, there, these, thick, thing, think, third, those, three, today, tools, total, touch, trace, track, trade, trail, train, tramp, trash, tread, treat, trees, tribe, trick, troll, tromp, troop, trout, truck, truly, trunk, trust, truth, uncle, under, until, value, visit, voice, vowel, watch, water, waves, where, which, while, white, whole, whose, wings, woman, women, words, world, would, write, wrong, wrote, years, young, across, action, afraid, agreed, almost, always, amount, answer, appear, around, became, become, before, behind, belong, beside, better, bleach, blonde, blouse, bottom, bought, braise, branch, breath, breeze, bridge, bright, broken, bronco, bronze, browse, bruise, called, cannot, cattle, caught, centre, chance, change, choose, church, circle, closet, clutch, colour, column, common, corner, cotton, course, cradle, crayon, create, crunch, desert, design, direct, doctor, dragon, during, effect, either, energy, engine, enough, entire, except, expect, family, famous, father, figure, filled, flight, flower, forest, freeze, friend, fright, fringe, frozen, garden, glance, glitch, grapes, grease, grouch, ground, grudge, inches, inside, island, itself, joined, jumped, killed, length, lifted, listen, little, matter, melody, method, middle, modern, moment, months, mother, nation, notice, number, object, office, oxygen, passed, people, period, person, phrase,  picked, plains, planet, plants, player, please, pledge, plenty, plural, pounds, praise, prance, prayer, pretty, priest, prince, prison, pulled, pushed, raised, rather, really, reason, record, region, remain, report, result, return, rhythm, rolled, scarce, school,
scorch, scrape, scrawl, scream, screen, script, scroll, second, seemed, should, silent, simple, single, sister, sketch, sleepy, sleeve, slight, slowly, smiled, smooth, smudge, snatch, sneeze, speech, spirit, splash, splint, sponge, sprain, sprang, sprawl, spread, spring, sprint, sprout, spruce, square, squash, squeak, squeal, squint, squirm, squirt, squish, stable, staple, starch, starve, statue, steady, stereo, sticky, stingy, stitch, strain, strand, streak, stream, street, strict, stride, strike, string, stripe, stroke, stroll, strong, struck, suffix, summer, supply, swatch, swerve, switch, system, though, toward, travel, trough, valley, walked, weight, wheels, window, winter, within, wonder, yellow, against, already, animals, another, arrived, because, believe, between, blanket, blossom, brother, brought, burning, capital, captain, century, certain, climate, climbed, clothes, company, compare, contain, control, correct, country, covered, cricket, current, decided, decimal, details, distant, divided, dollars, drawing, entered, evening, exactly, example, explain, express, factors, farmers, feeling, finally, fingers, flowers, forward, freight, friends, general, gravity, himself, history, however, hundred, hunting, include, insects, instead, laughed, letters, located, machine, measure, members, million, minutes, morning, natural, nothing, numeral, observe, outside, pattern, perhaps, picture, planets, prepare, present, pretzel, printed, problem, process, produce, product, program, project, promise, pronoun, protect, provide, quickly, reached, scallop, science, scooter, scraper, scratch, screech, section, settled, several, shouted, similar, skillet, slipper, snuggle, someone, special, squeeze, stadium, stapler, started, station, stirrup, stomach, strange, stretch, subject, suppose, surface, swallow, sweater, sweeten, swollen, symbols, teacher, thought, through, trouble, trumpet, usually, various, village, weather, western, whether, without, workers, written, actually, addition, although, anything, blizzard, branches, building, business, children, clothing, complete, compound, consider, describe, division, electric, elements, equation, everyone, exciting, exercise, finished, fraction, freckles, happened, increase, indicate, industry, interest, language,
material, movement, northern, opposite, pleasant, position, possible, practice, practise, precious, prepared, princess, prisoner, probably, products, property, received, remember, repeated, scallion, scramble, scribble, sentence, separate, shoulder, soldiers, solution, southern, splendid, splinter, sprinkle, squirrel, starfish, stocking, straight, strainer, stranger, strength, stronger, struggle, students, suddenly, surprise, together, triangle, yourself, adjective, beautiful, beginning, carefully, consonant, continued, determine, developed, different, difficult, direction, factories, following, groceries, important, molecules, mountains, necessary, paragraph, president, principal, professor, pronounce, propeller, questions, represent, something, sometimes, sprinkler, statement, stretched, stretcher, suggested, syllables, thousands, underline, blackboard, conditions, dictionary, difference, discovered, especially, everything, experience, experiment, flashlight, government, particular, scientists, stationary, strawberry, substances, themselves, understand
"""

""" after translation

"""